<template>
  <b-button
    variant="primary"
    v-b-modal.update-system-modal
    v-show="me && me.groups.includes('MOD')"
  >
    <b-icon-pencil />
    Update

    <b-modal
      id="update-system-modal"
      :title="`Update ${system.name}`"
      @ok="submit"
    >
      <p v-show="error" style="color: red">
        Something went wrong, please double-check your input or try it later
        again. Error message: {{ error }}
      </p>

      <b-form>
        <label for="name">Name</label>
        <b-form-input
          id="name"
          v-model="name"
          :state="name.length >= 3"
          placeholder="System name"
          trim
        />

        <label for="description">Description</label>
        <b-form-textarea
          id="description"
          v-model="description"
          placeholder="Describe your system..."
          trim
        />

        <label for="image">Image</label>
        <b-form-input
          id="image"
          v-model="image"
          placeholder="Image to illustrate the system"
          trim
        />

        <label for="logLink">Log Link</label>
        <b-form-input
          id="logLink"
          v-model="logLink"
          placeholder="Link to a page that explains testers where to get logs"
          trim
        />

        <label for="buildDiscovery">Build Discovery</label>
        <div id="buildDiscovery">
          <b-form-select
            v-model="discoveryEngine"
            :options="[
              { value: 'gitlab', text: 'GitLab releases' },
              { value: 'github', text: 'GitHub releases' },
              { value: 'openstore', text: 'Ubuntu Touch OpenStore' },
              { value: 'systemimage', text: 'Ubuntu Touch System-Image server' }
            ]"
          />
          <b-form-input
            v-model="discoveryArgs"
            placeholder="Build discovery arguments"
            trim
          />
        </div>
      </b-form>
    </b-modal>
  </b-button>
</template>

<script>
import gql from "graphql-tag";

export default {
  name: "UpdateSystem",
  data() {
    return {
      me: {
        groups: []
      },
      error: "",
      name: this.system.name || "",
      description: this.system.description || "",
      logLink: this.system.logLink || "",
      image: this.system.image || "",
      discoveryEngine: this.system?.buildDiscovery?.engine || "",
      discoveryArgs: this.system?.buildDiscovery?.args.join(", ") || ""
    };
  },
  apollo: {
    me: {
      query: gql`
        query {
          me {
            id
            name
            groups
            email
            joined
          }
        }
      `
    }
  },
  props: {
    system: Object
  },
  methods: {
    submit(e) {
      e.preventDefault();
      this.$apollo
        .mutate({
          mutation: gql`
            mutation($id: ID!, $system: SystemInput!) {
              updateSystem(id: $id, system: $system) {
                id
              }
            }
          `,
          variables: {
            id: this.system.id,
            system: {
              name: this.name || undefined,
              description: this.description || undefined,
              logLink: this.logLink || undefined,
              image: this.image || undefined,
              buildDiscovery:
                this.discoveryEngine && this.discoveryArgs
                  ? {
                      engine: this.discoveryEngine,
                      args: this.discoveryArgs.split(", ")
                    }
                  : undefined
            }
          }
        })
        .then(() => location.reload())
        .catch(error => {
          this.error = error;
        });
    }
  }
};
</script>
